defmodule CucumberGherkin.MixProject do
  use Mix.Project

  @github "https://github.com/cucumber/gherkin/tree/main/elixir"

  def project do
    [
      app: :cucumber_gherkin,
      version: "33.1.0",
      name: "CucumberGherkin",
      description: description(),
      package: package(),
      elixir: "~> 1.10",
      start_permanent: Mix.env() == :prod,
      deps: deps()
    ]
  end

  # Run "mix help compile.app" to learn about applications.
  def application do
    [
      extra_applications: [:logger]
    ]
  end

  # Run "mix help deps" to learn about dependencies.
  defp deps do
    [
      {:elixir_uuid, "~> 1.2"},
      {:cucumber_messages, ">= 27.0.2 and < 29.0.0"},
      {:ex_doc, "~> 0.38", only: :dev, runtime: false}
    ]
  end

  defp description() do
    "Elixir Gherkin parser."
  end

  defp package() do
    [
      licenses: ["MIT"],
      source_url: @github,
      links: %{"GitHub" => @github}
    ]
  end
end
